Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1060910 - Review Request: uid_wrapper - A wrapper for privilege separation
Summary: Review Request: uid_wrapper - A wrapper for privilege separation
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jakub Hrozek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-02-03 21:49 UTC by Andreas Schneider
Modified: 2014-08-22 19:16 UTC (History)
4 users (show)

Fixed In Version: uid_wrapper-1.0.2-2.el6
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-08-22 19:16:38 UTC
jhrozek: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Andreas Schneider 2014-02-03 21:49:35 UTC
Spec URL: http://xor.cryptomilk.org/rpm/uid_wrapper/uid_wrapper.spec
SRPM URL: http://xor.cryptomilk.org/rpm/uid_wrapper/uid_wrapper-1.0.0-1.fc20.src.rpm
Description: Some projects like a file server need privilege separation to be able to switch to the connnection user and do file operations. uid_wrapper convincingly lies to the application letting it believe it is operating as root and even switching betwen uids and gids as needed.

Fedora Account System Username: asn

NOTE: This is a special library you load with LD_PRELOAD. There is no header file and it will not be linked against any library!

Comment 1 Andreas Schneider 2014-02-04 16:25:21 UTC
Spec URL: http://xor.cryptomilk.org/rpm/uid_wrapper/uid_wrapper.spec
SRPM URL: http://xor.cryptomilk.org/rpm/uid_wrapper/uid_wrapper-1.0.1-1.fc20.src.rpm

ChangeLog of 1.0.1:
  * Added --libs to pkg-config.
  * Added socket_wrapper-config.cmake
  * Fixed a bug packaging the obj directory.

Comment 2 Andreas Schneider 2014-02-11 20:14:39 UTC
Spec URL: http://xor.cryptomilk.org/rpm/uid_wrapper/uid_wrapper.spec
SRPM URL: http://xor.cryptomilk.org/rpm/uid_wrapper/uid_wrapper-1.0.1-2.fc20.src.rpm

- Remove Group
- Remove glibc-devel build requirement
- Do not create a subpackage.

Comment 3 Jakub Hrozek 2014-03-11 09:32:28 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Development (unversioned) .so files in -devel subpackage, if present.
  Note: Unversioned so-files directly in %_libdir.
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#DevelPackages


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
     ----> Yes, the package is licensed with GPLv3
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v3 or later)", "Unknown or generated". 6 files have unknown
     license. Detailed output of licensecheck in
     /home/remote/jhrozek/rpmbuild/SRPMS/uid_wrapper/licensecheck.txt
     ----> Yes, COPYING contains GPLv3
[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by:
     /usr/lib64/pkgconfig(socket_wrapper, pkgconfig, libsocket_wrapper),
     /usr/lib64/cmake(socket_wrapper, cmake, libsocket_wrapper)
     ----> This allows the package to be installed even without pkgconfig
           or cmake
[x]: %build honors applicable compiler flags or justifies otherwise.
     ----> Yes, the %cmake macro expands to using the right CFLAGS
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
    ----> Installing the library into %libdir might seem strange a bit,
    but uid_wrapper is an exception in this regard. See discussion in bug
    #1060909 for more details.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[-]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 51200 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
     Note: uid_wrapper : /usr/lib64/pkgconfig/uid_wrapper.pc
[-]: Scriptlets must be sane, if used.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: uid_wrapper-1.0.1-2.fc20.x86_64.rpm
          uid_wrapper-1.0.1-2.fc20.src.rpm
uid_wrapper.x86_64: W: spelling-error Summary(en_US) seperation -> separation, desperation, exasperation
uid_wrapper.x86_64: W: spelling-error %description -l en_US connnection -> connection, Connecticut, connective
uid_wrapper.x86_64: W: spelling-error %description -l en_US uid -> yid, id, aid
uid_wrapper.x86_64: W: spelling-error %description -l en_US betwen -> between, bet wen, bet-wen
uid_wrapper.x86_64: W: spelling-error %description -l en_US uids -> yids, ids, aids
uid_wrapper.x86_64: W: spelling-error %description -l en_US gids -> digs, gods, ids
uid_wrapper.x86_64: W: spelling-error %description -l en_US devel -> delve, devil, revel
uid_wrapper.x86_64: W: shared-lib-calls-exit /usr/lib64/libuid_wrapper.so.0.0.1 exit@GLIBC_2.2.5
uid_wrapper.x86_64: W: devel-file-in-non-devel-package /usr/lib64/pkgconfig/uid_wrapper.pc
uid_wrapper.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libuid_wrapper.so
uid_wrapper.src: W: spelling-error Summary(en_US) seperation -> separation, desperation, exasperation
uid_wrapper.src: W: spelling-error %description -l en_US connnection -> connection, Connecticut, connective
uid_wrapper.src: W: spelling-error %description -l en_US uid -> yid, id, aid
uid_wrapper.src: W: spelling-error %description -l en_US betwen -> between, bet wen, bet-wen
uid_wrapper.src: W: spelling-error %description -l en_US uids -> yids, ids, aids
uid_wrapper.src: W: spelling-error %description -l en_US gids -> digs, gods, ids
uid_wrapper.src: W: spelling-error %description -l en_US devel -> delve, devil, revel
2 packages and 0 specfiles checked; 0 errors, 17 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint uid_wrapper
uid_wrapper.x86_64: W: spelling-error Summary(en_US) seperation -> separation, desperation, exasperation
uid_wrapper.x86_64: W: spelling-error %description -l en_US connnection -> connection, Connecticut, connective
uid_wrapper.x86_64: W: spelling-error %description -l en_US uid -> yid, id, aid
uid_wrapper.x86_64: W: spelling-error %description -l en_US betwen -> between, bet wen, bet-wen
uid_wrapper.x86_64: W: spelling-error %description -l en_US uids -> yids, ids, aids
uid_wrapper.x86_64: W: spelling-error %description -l en_US gids -> digs, gods, ids
uid_wrapper.x86_64: W: spelling-error %description -l en_US devel -> delve, devil, revel
uid_wrapper.x86_64: W: shared-lib-calls-exit /usr/lib64/libuid_wrapper.so.0.0.1 exit@GLIBC_2.2.5
uid_wrapper.x86_64: W: devel-file-in-non-devel-package /usr/lib64/pkgconfig/uid_wrapper.pc
uid_wrapper.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libuid_wrapper.so
1 packages and 0 specfiles checked; 0 errors, 10 warnings.
# echo 'rpmlint-done:'



Requires
--------
uid_wrapper (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    /usr/bin/pkg-config
    ld-linux-x86-64.so.2()(64bit)
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libpthread.so.0()(64bit)
    libuid_wrapper.so.0()(64bit)
    rtld(GNU_HASH)



Provides
--------
uid_wrapper:
    libuid_wrapper.so.0()(64bit)
    pkgconfig(uid_wrapper)
    uid_wrapper
    uid_wrapper(x86-64)



Unversioned so-files
--------------------
uid_wrapper: /usr/lib64/libuid_wrapper.so

Source checksums
----------------
https://ftp.samba.org/pub/cwrap/uid_wrapper-1.0.1.tar.gz :
  CHECKSUM(SHA256) this package     : 7ea768b419e1ab178c64eb62f614e7e11d9f02234b88c6a9ffda66545fd29c97
  CHECKSUM(SHA256) upstream package : 7ea768b419e1ab178c64eb62f614e7e11d9f02234b88c6a9ffda66545fd29c97

Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review --rpm-spec -n uid_wrapper-1.0.1-2.fc20.src.rpm
Buildroot used: fedora-20-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 4 Jakub Hrozek 2014-03-11 09:34:55 UTC
(In reply to Jakub Hrozek from comment #3)
> Issues:
> =======
> - Development (unversioned) .so files in -devel subpackage, if present.
>   Note: Unversioned so-files directly in %_libdir.
>   See: http://fedoraproject.org/wiki/Packaging/Guidelines#DevelPackages

Sorry, I didn't add a comment properly. As discussed in bug #1060909, this is probably the best way to go and allow the preloading (which is the point of the wrappers) easily.

I short, I don't have any issues with the package. It's very similar to socket_wrapper which already passed a review, so it went quite smooth.

Comment 5 Jakub Hrozek 2014-03-11 09:37:51 UTC
Ugh, I rushed too much. There are some spelling errors in %description:

uid_wrapper.x86_64: W: spelling-error Summary(en_US) seperation -> separation, desperation, exasperation
uid_wrapper.x86_64: W: spelling-error %description -l en_US connnection -> connection, Connecticut, connective
uid_wrapper.x86_64: W: spelling-error %description -l en_US uid -> yid, id, aid
uid_wrapper.x86_64: W: spelling-error %description -l en_US betwen -> between, bet wen, bet-wen
uid_wrapper.x86_64: W: spelling-error %description -l en_US uids -> yids, ids, aids
uid_wrapper.x86_64: W: spelling-error %description -l en_US gids -> digs, gods, ids

These seem like valid errors to me. Feel free to fix them when you import the package. At least "seperation", "connnection" and "betwen" should be fixed. uid and gid would look better as UID and GID, but I don't really mind about those.

Comment 6 Andreas Schneider 2014-03-11 09:44:51 UTC
Thanks, I will fix them after import!

Comment 7 Andreas Schneider 2014-03-11 09:45:40 UTC
New Package SCM Request
=======================
Package Name: uid_wrapper
Short Description: A wrapper for privilege separation
Owners: asn
Branches: f20 epel7
InitialCC: jhrozek

Comment 8 Gwyn Ciesla 2014-03-11 12:07:14 UTC
Git done (by process-git-requests).

Comment 9 Fedora Update System 2014-03-11 14:09:29 UTC
uid_wrapper-1.0.1-3.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/uid_wrapper-1.0.1-3.fc20

Comment 10 Fedora Update System 2014-03-12 12:20:52 UTC
uid_wrapper-1.0.1-3.fc20 has been pushed to the Fedora 20 testing repository.

Comment 11 Fedora Update System 2014-03-21 09:32:45 UTC
uid_wrapper-1.0.1-3.fc20 has been pushed to the Fedora 20 stable repository.

Comment 12 Andreas Schneider 2014-08-04 08:46:53 UTC
Package Change Request
======================
Package Name: uid_wrapper
New Branches: el6
Owners: asn jhrozek

Comment 13 Gwyn Ciesla 2014-08-04 12:10:35 UTC
Git done (by process-git-requests).

Comment 14 Fedora Update System 2014-08-07 11:31:16 UTC
uid_wrapper-1.0.2-2.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/uid_wrapper-1.0.2-2.el6

Comment 15 Fedora Update System 2014-08-08 00:41:54 UTC
uid_wrapper-1.0.2-2.el6 has been pushed to the Fedora EPEL 6 testing repository.

Comment 16 Fedora Update System 2014-08-22 19:16:38 UTC
uid_wrapper-1.0.2-2.el6 has been pushed to the Fedora EPEL 6 stable repository.


Note You need to log in before you can comment on or make changes to this bug.